package babillard

import (
	"flag"

	"codeberg.org/vlbeaudoin/couleuvre"
)

var app couleuvre.App[Config]

func init() {
	app = couleuvre.App[Config]{EnvPrefix: "babillard"}

	flag.StringVar(&app.Config.ServerContenuDir, ServerContenuDirName, ServerContenuDirDefault, ServerContenuDirDescription)
	flag.IntVar(&app.Config.ServerPort, ServerPortName, ServerPortDefault, ServerPortDescription)
}

const (
	ServerContenuDirName        = "servercontenudir"
	ServerContenuDirDefault     = "contenu"
	ServerContenuDirDescription = "Répertoire du contenu à exposer"

	ServerPortName            = "serverport"
	ServerPortDefault     int = 8080
	ServerPortDescription     = "Port réseau à utiliser pour le serveur"
)

const (
	ServerCmdName = "server"
	ServerCmdDesc = "Démarrer le serveur web"
)

func ServerCmdExecuter(args ...string) error {
	RunServer(app.Config)
	return nil
}

func Execute() error {
	if err := app.AddCommands(couleuvre.Command{
		Name:        ServerCmdName,
		Description: ServerCmdDesc,
		Executer:    couleuvre.ExecuterFunc(ServerCmdExecuter),
	}); err != nil {
		return err
	}

	if err := app.Parse(); err != nil {
		return err
	}

	if err := app.Execute(flag.Args()...); err != nil {
		return err
	}

	return nil
}
